; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Gaming Maths library
; Fichier : Matrix34 - Module.pb
; Version : 1.1.0
; Programmation : OK
; Programm par : StarBootics
; Date : 20-05-2007
; Mise  jour : 03-03-2015
; Cod pour PureBasic V5.31
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Notes : Matrix34
;
; La matrice se prsente sous la forme suivante :
;
; lments Matrice     -->  Index du tableau 1D
; 3x4 = 12 lments    -->  12 case de 0  11
; 
; [e11, e12, e13, e14] -->  [00, 03, 06, 09] 
; [e21, e22, e23, e24] -->  [01, 04, 07, 10]
; [e31, e32, e33, e34] -->  [02, 05, 08, 11]
;
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


DeclareModule Matrix34

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Dclaration de la Structure <<<<<

  Structure Matrix34

    e11.f
    e21.f
    e31.f
    e12.f
    e22.f
    e32.f
    e13.f
    e23.f
    e33.f
    e14.f
    e24.f
    e34.f

  EndStructure

  Declare Reset(*Matrix34A.Matrix34)
  Declare Equal(*Matrix34A.Matrix34, *Matrix34B.Matrix34)
  Declare Plus(*Matrix34R.Matrix34, *Matrix34A.Matrix34, *Matrix34B.Matrix34)
  Declare Minus(*Matrix34R.Matrix34, *Matrix34A.Matrix34, *Matrix34B.Matrix34)
  Declare Zero(*Matrix34A.Matrix34)
  Declare One(*Matrix34A.Matrix34)
  Declare ProductByScalar(*Matrix34R.Matrix34, *Matrix34A.Matrix34, P_Scalar.f)
  Declare DivideByScalar(*Matrix34R.Matrix34, *Matrix34A.Matrix34, P_Scalar.f)
  Declare Copy(*Matrix34A.Matrix34, *Matrix34B.Matrix34)
  Declare Compare(*Matrix34A.Matrix34, *Matrix34B.Matrix34)
  Declare Swapping(*Matrix34A.Matrix34, *Matrix34B.Matrix34)
  Declare Randomize(*Matrix34A.Matrix34, Min.f, Max.f, Resolution = 10000)
  Declare.s FormatLine1(*Matrix34A.Matrix34, Decimal = 3)
  Declare.s FormatLine2(*Matrix34A.Matrix34, Decimal = 3)
  Declare.s FormatLine3(*Matrix34A.Matrix34, Decimal = 3)
  Declare UnformatLine1(*Matrix34A.Matrix34, P_MatrixLine.s)
  Declare UnformatLine2(*Matrix34A.Matrix34, P_MatrixLine.s)
  Declare UnformatLine3(*Matrix34A.Matrix34, P_MatrixLine.s)
  Declare ReadMatrix34(FileID.l, *Matrix34A.Matrix34)
  Declare WriteMatrix34(FileID.l, *Matrix34A.Matrix34)
  Declare SetMatrix34Line1(*Matrix34A.Matrix34, P_e11.f, P_e12.f, P_e13.f, P_e14.f)
  Declare SetMatrix34Line2(*Matrix34A.Matrix34, P_e21.f, P_e22.f, P_e23.f, P_e24.f)
  Declare SetMatrix34Line3(*Matrix34A.Matrix34, P_e31.f, P_e32.f, P_e33.f, P_e34.f)
  
  CompilerIf Defined(Vector3, #PB_Module)
    Declare ProductMatrixVector(*VectorR.Vector3::Vector3, *MatrixA.Matrix34, *VectorB.Vector3::Vector3)
    Declare TransformPosition(*NewPosition.Vector3::Vector3, *MatrixA.Matrix34, *OldPosition.Vector3::Vector3)
    Declare TransformPositionInverse(*NewPosition.Vector3::Vector3, *MatrixA.Matrix34, *OldPosition.Vector3::Vector3)
    Declare TransformDirection(*NewDirection.Vector3::Vector3, *MatrixA.Matrix34, *OldDirection.Vector3::Vector3)
    Declare TransformDirectionInverse(*NewDirection.Vector3::Vector3, *MatrixA.Matrix34, *OldDirection.Vector3::Vector3)
  CompilerEndIf
  
EndDeclareModule

Module Matrix34

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset(*Matrix34A.Matrix34)
    
    *Matrix34A\e11 = 0.0
    *Matrix34A\e21 = 0.0
    *Matrix34A\e31 = 0.0
    *Matrix34A\e12 = 0.0
    *Matrix34A\e22 = 0.0
    *Matrix34A\e32 = 0.0
    *Matrix34A\e13 = 0.0
    *Matrix34A\e23 = 0.0
    *Matrix34A\e33 = 0.0
    *Matrix34A\e14 = 0.0
    *Matrix34A\e24 = 0.0
    *Matrix34A\e34 = 0.0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Equal : A = B <<<<<

  Procedure Equal(*Matrix34A.Matrix34, *Matrix34B.Matrix34)

    *Matrix34A\e11 = *Matrix34B\e11
    *Matrix34A\e21 = *Matrix34B\e21
    *Matrix34A\e31 = *Matrix34B\e31
    *Matrix34A\e12 = *Matrix34B\e12
    *Matrix34A\e22 = *Matrix34B\e22
    *Matrix34A\e32 = *Matrix34B\e32
    *Matrix34A\e13 = *Matrix34B\e13
    *Matrix34A\e23 = *Matrix34B\e23
    *Matrix34A\e33 = *Matrix34B\e33
    *Matrix34A\e14 = *Matrix34B\e14
    *Matrix34A\e24 = *Matrix34B\e24
    *Matrix34A\e34 = *Matrix34B\e34

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Plus : R = A + B <<<<<

  Procedure Plus(*Matrix34R.Matrix34, *Matrix34A.Matrix34, *Matrix34B.Matrix34)

    *Matrix34R\e11 = *Matrix34A\e11 + *Matrix34B\e11
    *Matrix34R\e21 = *Matrix34A\e21 + *Matrix34B\e21
    *Matrix34R\e31 = *Matrix34A\e31 + *Matrix34B\e31
    *Matrix34R\e12 = *Matrix34A\e12 + *Matrix34B\e12
    *Matrix34R\e22 = *Matrix34A\e22 + *Matrix34B\e22
    *Matrix34R\e32 = *Matrix34A\e32 + *Matrix34B\e32
    *Matrix34R\e13 = *Matrix34A\e13 + *Matrix34B\e13
    *Matrix34R\e23 = *Matrix34A\e23 + *Matrix34B\e23
    *Matrix34R\e33 = *Matrix34A\e33 + *Matrix34B\e33
    *Matrix34R\e14 = *Matrix34A\e14 + *Matrix34B\e14
    *Matrix34R\e24 = *Matrix34A\e24 + *Matrix34B\e24
    *Matrix34R\e34 = *Matrix34A\e34 + *Matrix34B\e34

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Minus : R = A - B <<<<<

  Procedure Minus(*Matrix34R.Matrix34, *Matrix34A.Matrix34, *Matrix34B.Matrix34)

    *Matrix34R\e11 = *Matrix34A\e11 - *Matrix34B\e11
    *Matrix34R\e21 = *Matrix34A\e21 - *Matrix34B\e21
    *Matrix34R\e31 = *Matrix34A\e31 - *Matrix34B\e31
    *Matrix34R\e12 = *Matrix34A\e12 - *Matrix34B\e12
    *Matrix34R\e22 = *Matrix34A\e22 - *Matrix34B\e22
    *Matrix34R\e32 = *Matrix34A\e32 - *Matrix34B\e32
    *Matrix34R\e13 = *Matrix34A\e13 - *Matrix34B\e13
    *Matrix34R\e23 = *Matrix34A\e23 - *Matrix34B\e23
    *Matrix34R\e33 = *Matrix34A\e33 - *Matrix34B\e33
    *Matrix34R\e14 = *Matrix34A\e14 - *Matrix34B\e14
    *Matrix34R\e24 = *Matrix34A\e24 - *Matrix34B\e24
    *Matrix34R\e34 = *Matrix34A\e34 - *Matrix34B\e34

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Zero <<<<<

  Procedure Zero(*Matrix34A.Matrix34)
    
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    *Matrix34A = 0.0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur One <<<<<

  Procedure One(*Matrix34A.Matrix34)
    
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    *Matrix34A = 1.0
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur ProductByScalar : R = A * Scalar <<<<<

  Procedure ProductByScalar(*Matrix34R.Matrix34, *Matrix34A.Matrix34, P_Scalar.f)

    *Matrix34R\e11 = *Matrix34A\e11 * P_Scalar
    *Matrix34R\e21 = *Matrix34A\e21 * P_Scalar
    *Matrix34R\e31 = *Matrix34A\e31 * P_Scalar
    *Matrix34R\e12 = *Matrix34A\e12 * P_Scalar
    *Matrix34R\e22 = *Matrix34A\e22 * P_Scalar
    *Matrix34R\e32 = *Matrix34A\e32 * P_Scalar
    *Matrix34R\e13 = *Matrix34A\e13 * P_Scalar
    *Matrix34R\e23 = *Matrix34A\e23 * P_Scalar
    *Matrix34R\e33 = *Matrix34A\e33 * P_Scalar
    *Matrix34R\e14 = *Matrix34A\e14 * P_Scalar
    *Matrix34R\e24 = *Matrix34A\e24 * P_Scalar
    *Matrix34R\e34 = *Matrix34A\e34 * P_Scalar

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur DivideByScalar : R = A / Scalar <<<<<

  Procedure DivideByScalar(*Matrix34R.Matrix34, *Matrix34A.Matrix34, P_Scalar.f)

    *Matrix34R\e11 = *Matrix34A\e11 / P_Scalar
    *Matrix34R\e21 = *Matrix34A\e21 / P_Scalar
    *Matrix34R\e31 = *Matrix34A\e31 / P_Scalar
    *Matrix34R\e12 = *Matrix34A\e12 / P_Scalar
    *Matrix34R\e22 = *Matrix34A\e22 / P_Scalar
    *Matrix34R\e32 = *Matrix34A\e32 / P_Scalar
    *Matrix34R\e13 = *Matrix34A\e13 / P_Scalar
    *Matrix34R\e23 = *Matrix34A\e23 / P_Scalar
    *Matrix34R\e33 = *Matrix34A\e33 / P_Scalar
    *Matrix34R\e14 = *Matrix34A\e14 / P_Scalar
    *Matrix34R\e24 = *Matrix34A\e24 / P_Scalar
    *Matrix34R\e34 = *Matrix34A\e34 / P_Scalar

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Copy : A = Source : B = Destination <<<<<

  Procedure Copy(*Matrix34A.Matrix34, *Matrix34B.Matrix34)

    *Matrix34B\e11 = *Matrix34A\e11
    *Matrix34B\e21 = *Matrix34A\e21
    *Matrix34B\e31 = *Matrix34A\e31
    *Matrix34B\e12 = *Matrix34A\e12
    *Matrix34B\e22 = *Matrix34A\e22
    *Matrix34B\e32 = *Matrix34A\e32
    *Matrix34B\e13 = *Matrix34A\e13
    *Matrix34B\e23 = *Matrix34A\e23
    *Matrix34B\e33 = *Matrix34A\e33
    *Matrix34B\e14 = *Matrix34A\e14
    *Matrix34B\e24 = *Matrix34A\e24
    *Matrix34B\e34 = *Matrix34A\e34

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Compare <<<<<

  Procedure Compare(*Matrix34A.Matrix34, *Matrix34B.Matrix34)

    If *Matrix34A\e11 <> *Matrix34B\e11
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e21 <> *Matrix34B\e21
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e31 <> *Matrix34B\e31
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e12 <> *Matrix34B\e12
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e22 <> *Matrix34B\e22
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e32 <> *Matrix34B\e32
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e13 <> *Matrix34B\e13
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e23 <> *Matrix34B\e23
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e33 <> *Matrix34B\e33
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e14 <> *Matrix34B\e14
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e24 <> *Matrix34B\e24
      ProcedureReturn #False
    EndIf

    If *Matrix34A\e34 <> *Matrix34B\e34
      ProcedureReturn #False
    EndIf

    ProcedureReturn #True
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Swapping <<<<<

  Procedure Swapping(*Matrix34A.Matrix34, *Matrix34B.Matrix34)

    Swap *Matrix34A\e11, *Matrix34B\e11
    Swap *Matrix34A\e21, *Matrix34B\e21
    Swap *Matrix34A\e31, *Matrix34B\e31
    Swap *Matrix34A\e12, *Matrix34B\e12
    Swap *Matrix34A\e22, *Matrix34B\e22
    Swap *Matrix34A\e32, *Matrix34B\e32
    Swap *Matrix34A\e13, *Matrix34B\e13
    Swap *Matrix34A\e23, *Matrix34B\e23
    Swap *Matrix34A\e33, *Matrix34B\e33
    Swap *Matrix34A\e14, *Matrix34B\e14
    Swap *Matrix34A\e24, *Matrix34B\e24
    Swap *Matrix34A\e34, *Matrix34B\e34

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Random <<<<<

  Procedure Randomize(*Matrix34A.Matrix34, Min.f, Max.f, Resolution = 10000)

    *Matrix34A\e11 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e21 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e31 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e12 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e22 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e32 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e13 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e23 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e33 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e14 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e24 = (Min + (Max - Min) * Random(Resolution) / Resolution)
    *Matrix34A\e34 = (Min + (Max - Min) * Random(Resolution) / Resolution)

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les oprateurs de Formatage <<<<<

  Procedure.s FormatLine1(*Matrix34A.Matrix34, Decimal = 3)

    ProcedureReturn "[" + StrF(*Matrix34A\e11, Decimal) + " : " + StrF(*Matrix34A\e12, Decimal) + " : " + StrF(*Matrix34A\e13, Decimal) + " : " + StrF(*Matrix34A\e14, Decimal) + "]"
  EndProcedure

  Procedure.s FormatLine2(*Matrix34A.Matrix34, Decimal = 3)

    ProcedureReturn "[" + StrF(*Matrix34A\e21, Decimal) + " : " + StrF(*Matrix34A\e22, Decimal) + " : " + StrF(*Matrix34A\e23, Decimal) + " : " + StrF(*Matrix34A\e24, Decimal) + "]"
  EndProcedure

  Procedure.s FormatLine3(*Matrix34A.Matrix34, Decimal = 3)

    ProcedureReturn "[" + StrF(*Matrix34A\e31, Decimal) + " : " + StrF(*Matrix34A\e32, Decimal) + " : " + StrF(*Matrix34A\e33, Decimal) + " : " + StrF(*Matrix34A\e34, Decimal) + "]"
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les oprateurs de Dformatage <<<<<

  Procedure UnformatLine1(*Matrix34A.Matrix34, P_MatrixLine.s)

    *Matrix34A\e11 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 1, ":"))
    *Matrix34A\e12 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 2, ":"))
    *Matrix34A\e13 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 3, ":"))
    *Matrix34A\e14 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 4, ":"))

  EndProcedure

  Procedure UnformatLine2(*Matrix34A.Matrix34, P_MatrixLine.s)

    *Matrix34A\e21 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 1, ":"))
    *Matrix34A\e22 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 2, ":"))
    *Matrix34A\e23 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 3, ":"))
    *Matrix34A\e24 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 4, ":"))

  EndProcedure

  Procedure UnformatLine3(*Matrix34A.Matrix34, P_MatrixLine.s)

    *Matrix34A\e31 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 1, ":"))
    *Matrix34A\e32 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 2, ":"))
    *Matrix34A\e33 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 3, ":"))
    *Matrix34A\e34 = ValF(StringField(StringField(StringField(P_MatrixLine, 2, "["), 1, "]"), 4, ":"))

  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture sur fichier Binaire <<<<<

  Procedure ReadMatrix34(FileID.l, *Matrix34A.Matrix34)
    
    *Matrix34A\e11 = ReadFloat(FileID)
    *Matrix34A\e21 = ReadFloat(FileID)
    *Matrix34A\e31 = ReadFloat(FileID)
    *Matrix34A\e12 = ReadFloat(FileID)
    *Matrix34A\e22 = ReadFloat(FileID)
    *Matrix34A\e32 = ReadFloat(FileID)
    *Matrix34A\e13 = ReadFloat(FileID)
    *Matrix34A\e23 = ReadFloat(FileID)
    *Matrix34A\e33 = ReadFloat(FileID)
    *Matrix34A\e14 = ReadFloat(FileID)
    *Matrix34A\e24 = ReadFloat(FileID)
    *Matrix34A\e34 = ReadFloat(FileID)
    
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture sur fichier Binaire <<<<<

  Procedure WriteMatrix34(FileID.l, *Matrix34A.Matrix34)
    
    WriteFloat(FileID, *Matrix34A\e11)
    WriteFloat(FileID, *Matrix34A\e21)
    WriteFloat(FileID, *Matrix34A\e31)
    WriteFloat(FileID, *Matrix34A\e12)
    WriteFloat(FileID, *Matrix34A\e22)
    WriteFloat(FileID, *Matrix34A\e32)
    WriteFloat(FileID, *Matrix34A\e13)
    WriteFloat(FileID, *Matrix34A\e23)
    WriteFloat(FileID, *Matrix34A\e33)
    WriteFloat(FileID, *Matrix34A\e14)
    WriteFloat(FileID, *Matrix34A\e24)
    WriteFloat(FileID, *Matrix34A\e34)
    
  EndProcedure
    
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Les mutateur ligne par ligne <<<<<
  
  Procedure SetMatrix34Line1(*Matrix34A.Matrix34, P_e11.f, P_e12.f, P_e13.f, P_e14.f)
    
    *Matrix34A\e11 = P_e11
    *Matrix34A\e12 = P_e12
    *Matrix34A\e13 = P_e13
    *Matrix34A\e14 = P_e14
    
  EndProcedure
  
  Procedure SetMatrix34Line2(*Matrix34A.Matrix34, P_e21.f, P_e22.f, P_e23.f, P_e24.f)
    
    *Matrix34A\e21 = P_e21
    *Matrix34A\e22 = P_e22
    *Matrix34A\e23 = P_e23
    *Matrix34A\e24 = P_e24
    
  EndProcedure
  
  Procedure SetMatrix34Line3(*Matrix34A.Matrix34, P_e31.f, P_e32.f, P_e33.f, P_e34.f)
    
    *Matrix34A\e31 = P_e31
    *Matrix34A\e32 = P_e32
    *Matrix34A\e33 = P_e33
    *Matrix34A\e34 = P_e34
    
  EndProcedure
  
  CompilerIf Defined(Vector3, #PB_Module)
    
    Procedure ProductMatrixVector(*VectorR.Vector3::Vector3, *MatrixA.Matrix34, *VectorB.Vector3::Vector3)
      
      *Vector3R\i = *MatrixA\e11 * *VectorB\i + *MatrixA\e12 * *VectorB\j + *MatrixA\e13 * *VectorB\k + *MatrixA\e14 
      *Vector3R\j = *MatrixA\e21 * *VectorB\i + *MatrixA\e22 * *VectorB\j + *MatrixA\e23 * *VectorB\k + *MatrixA\e24 
      *Vector3R\k = *MatrixA\e31 * *VectorB\i + *MatrixA\e32 * *VectorB\j + *MatrixA\e33 * *VectorB\k + *MatrixA\e34
           
    EndProcedure
       
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ;  noter que ces transformations 3D sont valides uniquement si la matrice
    ; de transformation contient que des rotations et translation. Ce qui est
    ; le cas lors d'une simulation de corps rigide.
    
    Procedure TransformPosition(*NewPosition.Vector3::Vector3, *MatrixA.Matrix34, *OldPosition.Vector3::Vector3)
      
      *NewPosition\i = *MatrixA\e11 * *OldPosition\i + *MatrixA\e12 * *OldPosition\j + *MatrixA\e13 * *OldPosition\k + *MatrixA\e14 
      *NewPosition\j = *MatrixA\e21 * *OldPosition\i + *MatrixA\e22 * *OldPosition\j + *MatrixA\e23 * *OldPosition\k + *MatrixA\e24 
      *NewPosition\k = *MatrixA\e31 * *OldPosition\i + *MatrixA\e32 * *OldPosition\j + *MatrixA\e33 * *OldPosition\k + *MatrixA\e34
           
    EndProcedure
    
    Procedure TransformPositionInverse(*NewPosition.Vector3::Vector3, *MatrixA.Matrix34, *OldPosition.Vector3::Vector3)
      
      *OldPosition\i = *OldPosition\i - *MatrixA\e14 
      *OldPosition\j = *OldPosition\j - *MatrixA\e24 
      *OldPosition\k = *OldPosition\k - *MatrixA\e34 
      
      *NewPosition\i = *MatrixA\e11 * *OldPosition\i + *MatrixA\e21 * *OldPosition\j + *MatrixA\e31 * *OldPosition\k
      *NewPosition\j = *MatrixA\e12 * *OldPosition\i + *MatrixA\e22 * *OldPosition\j + *MatrixA\e32 * *OldPosition\k 
      *NewPosition\k = *MatrixA\e13 * *OldPosition\i + *MatrixA\e23 * *OldPosition\j + *MatrixA\e33 * *OldPosition\k
           
    EndProcedure
    
    Procedure TransformDirection(*NewDirection.Vector3::Vector3, *MatrixA.Matrix34, *OldDirection.Vector3::Vector3)
      
      *NewDirection\i = *MatrixA\e11 * *VectorB\i + *MatrixA\e12 * *OldDirection\j + *MatrixA\e13 * *OldDirection\k 
      *NewDirection\j = *MatrixA\e21 * *VectorB\i + *MatrixA\e22 * *OldDirection\j + *MatrixA\e23 * *OldDirection\k
      *NewDirection\k = *MatrixA\e31 * *VectorB\i + *MatrixA\e32 * *OldDirection\j + *MatrixA\e33 * *OldDirection\k
      
    EndProcedure
    
    Procedure TransformDirectionInverse(*NewDirection.Vector3::Vector3, *MatrixA.Matrix34, *OldDirection.Vector3::Vector3)
      
      *NewDirection\i = *MatrixA\e11 * *OldDirection\i + *MatrixA\e21 * *OldDirection\j + *MatrixA\e31 * *OldDirection\k 
      *NewDirection\j = *MatrixA\e12 * *OldDirection\i + *MatrixA\e22 * *OldDirection\j + *MatrixA\e32 * *OldDirection\k
      *NewDirection\k = *MatrixA\e13 * *OldDirection\i + *MatrixA\e23 * *OldDirection\j + *MatrixA\e33 * *OldDirection\k
      
    EndProcedure
    
  CompilerEndIf
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 beta 1 (Linux - x64)
; Folding = ------
; EnableXP
; CompileSourceDirectory