; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : Plane - Module
; File Name : Plane - Module.pb
; File version: 1.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 09-03-2015
; Last Update : 02-06-2016
; PureBasic code : V5.42 LTS
; Platform : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;
; This code is free to be use where ever you like
; but you use it at your own risk.
;
; The author can in no way be held responsible
; for data loss, damage or other annoying
; situations that may occur.
;
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

CompilerIf #PB_Compiler_IsMainFile
 
  IncludeFile "Vector3 - Module.pb"
 
CompilerEndIf

DeclareModule Plane
 
  Structure Plane
   
    A.f
    B.f
    C.f
    D.f
   
  EndStructure
 
  Declare Update(*PlaneA.Plane, P_A.f, P_B.f, P_C.f, P_D.f)
  Declare Reset(*PlaneA.Plane)
  Declare ReadPlane(FileID.l, *PlaneA.Plane)
  Declare WritePlane(FileID.l, *PlaneA.Plane)
  Declare.s Format(*PlaneA.Plane, Decimal.b = 3)
  Declare UnFormat(*PlaneA.Plane, Formated.s)
 
  CompilerIf Defined(Vector3, #PB_Module)
    Declare.f Distance(*PlaneA.Plane, *VectorA.Vector3::Vector3)
    Declare.f Evaluate(*PlaneA.Plane, *VectorA.Vector3::Vector3)
    Declare FromPoints(*PlaneA.Plane, *VectorA.Vector3::Vector3, *VectorB.Vector3::Vector3, *VectorC.Vector3::Vector3)
    Declare IsPointInside(*PlaneA.Plane, *VectorA.Vector3::Vector3)
  CompilerEndIf
 
EndDeclareModule

Module Plane
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Update <<<<<
 
  Procedure Update(*PlaneA.Plane, P_A.f, P_B.f, P_C.f, P_D.f)
   
    *PlaneA\A = P_A
    *PlaneA\B = P_B
    *PlaneA\C = P_C
    *PlaneA\D = P_D
   
  EndProcedure
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< L'oprateur Reset <<<<<

  Procedure Reset(*PlaneA.Plane)
   
    *PlaneA\A = 0.0
    *PlaneA\B = 0.0
    *PlaneA\C = 0.0
    *PlaneA\D = 0.0
   
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Lecture sur fichier Binaire <<<<<

  Procedure ReadPlane(FileID.l, *PlaneA.Plane)
   
    *PlaneA\A = ReadFloat(FileID)
    *PlaneA\B = ReadFloat(FileID)
    *PlaneA\C = ReadFloat(FileID)
    *PlaneA\D = ReadFloat(FileID)
   
  EndProcedure

  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< criture sur fichier Binaire <<<<<

  Procedure WritePlane(FileID.l, *PlaneA.Plane)
   
    WriteFloat(FileID, *PlaneA\A)
    WriteFloat(FileID, *PlaneA\B)
    WriteFloat(FileID, *PlaneA\C)
    WriteFloat(FileID, *PlaneA\D)
   
  EndProcedure
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Formatage de l'quation du plan <<<<<
 
  Procedure.s Format(*PlaneA.Plane, Decimal.b = 3)
   
    ProcedureReturn StrF(*PlaneA\A, Decimal) + "x + " + StrF(*PlaneA\B, Decimal) + "y + " + StrF(*PlaneA\C, Decimal) + "z = " + StrD(*PlaneA\D, Decimal)
  EndProcedure
 
  Procedure UnFormat(*PlaneA.Plane, Formated.s)
   
    *PlaneA\A = ValF(StringField(Trim(StringField(Formated, 1, "+")), 1, "x"))
    *PlaneA\B = ValF(StringField(Trim(StringField(Formated, 2, "+")), 1, "y"))
    *PlaneA\C = ValF(StringField(Trim(StringField(StringField(Formated, 1, "="), 3, "+")), 1, "z"))
    *PlaneA\D = ValF(Trim(StringField(Formated, 2, "=")))
   
  EndProcedure

  CompilerIf Defined(Vector3, #PB_Module)
   
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; <<<<< Distance Point plan <<<<<
 
    Procedure.f Distance(*PlaneA.Plane, *VectorA.Vector3::Vector3)
   
      ProcedureReturn (*PlaneA\A * *VectorA\i + *PlaneA\B * *VectorA\j + *PlaneA\C * *VectorA\k + *PlaneA\D) / Sqr(*PlaneA\A * *PlaneA\A + *PlaneA\B * *PlaneA\B + *PlaneA\C * *PlaneA\C)
    EndProcedure
 
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; <<<<< valuation du plan au point spcifi <<<<<
 
    Procedure.f Evaluate(*PlaneA.Plane, *VectorA.Vector3::Vector3)
   
      ProcedureReturn *PlaneA\A * *VectorA\i + *PlaneA\B * *VectorA\j + *PlaneA\C * *VectorA\k
    EndProcedure
 
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; <<<<< Un plan passant par 3 points <<<<<
 
    Procedure FromPoints(*PlaneA.Plane, *VectorA.Vector3::Vector3, *VectorB.Vector3::Vector3, *VectorC.Vector3::Vector3)
   
      Vector3::Minus(Alpha.Vector3::Vector3, *VectorB, *VectorA)
      Vector3::Minus(Beta.Vector3::Vector3, *VectorC, *VectorA)
      Vector3::CrossProduct(Normal.Vector3::Vector3, Alpha, Beta)
      Vector3::Unit(Normal)
      CopyMemory(Normal, *PlaneA, SizeOf(Vector3::Vector3))
      *PlaneA\D = *PlaneA\A * *VectorA\i + *PlaneA\B * *VectorA\j + *PlaneA\C * *VectorA\k
   
    EndProcedure
 
    Procedure IsPointInside(*PlaneA.Plane, *VectorA.Vector3::Vector3)
   
      If *PlaneA\A * *VectorA\i + *PlaneA\B * *VectorA\j + *PlaneA\C * *VectorA\k = *PlaneA\D
        Result = #True
      Else
        Result = #False
      EndIf
   
      ProcedureReturn Result
    EndProcedure

  CompilerEndIf

EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< Code gnr en : 00.001 secondes (75000.00 lignes/seconde) <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

CompilerIf #PB_Compiler_IsMainFile

  Vector3::Update(P.Vector3::Vector3, 0.0, 0.0, 1.0)
  Vector3::Update(Q.Vector3::Vector3, 4.0, 2.0, 3.0)
  Vector3::Update(R.Vector3::Vector3, -3.0, 1.0, 1.0)
 
  Vector3::Update(S.Vector3::Vector3, -9.0, -10.0, -25.0)
  Vector3::Update(T.Vector3::Vector3, 9.0, 10.0, 25.0)
 
  Plane::FromPoints(Plane.Plane::Plane, P, Q, R)
 
  Debug Plane::Format(Plane)
  Debug Plane::Evaluate(Plane, P)
  Debug Plane::Evaluate(Plane, Q)
  Debug Plane::Evaluate(Plane, R)
 
  Debug ""
 
  Debug Plane::IsPointInside(Plane, S)
  Debug Plane::IsPointInside(Plane, T)
 
  Debug ""
 
  Debug Plane::Distance(Plane, S)
  Debug Plane::Distance(Plane, T)

CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 beta 1 (Linux - x64)
; Folding = ---
; EnableXP
; CompileSourceDirectory