; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Gaming Maths library
; Nom du fichier : Quaternion - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : StarBootics
; Date : 03-03-2015
; Mise  jour : 03-03-2015
; Code PureBasic : 5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Quaternion
  
  Structure Quaternion
    
    s.f
    i.f
    j.f
    k.f
    
  EndStructure
  
  Declare.f GetS(*QuaternionA.Quaternion)
  Declare.f GetI(*QuaternionA.Quaternion)
  Declare.f GetJ(*QuaternionA.Quaternion)
  Declare.f GetK(*QuaternionA.Quaternion)
  
  Declare SetS(*QuaternionA.Quaternion, P_s.f)
  Declare SetI(*QuaternionA.Quaternion, P_i.f)
  Declare SetJ(*QuaternionA.Quaternion, P_j.f)
  Declare SetK(*QuaternionA.Quaternion, P_k.f)
  
  Declare Update(*QuaternionA.Quaternion, P_s.f, P_i.f, P_j.f, P_k.f)
  
  Declare Reset(*QuaternionA.Quaternion)
  Declare Copy(*QuaternionA.Quaternion, *QuaternionB.Quaternion)
  Declare Compare(*QuaternionA.Quaternion, *QuaternionB.Quaternion)
  Declare Swapping(*QuaternionA.Quaternion, *QuaternionB.Quaternion)

  Declare Equal(*QuaternionA.Quaternion, *QuaternionB.Quaternion)
  Declare Plus(*QuaternionR.Quaternion, *QuaternionA.Quaternion, *QuaternionB.Quaternion)
  Declare Minus(*QuaternionR.Quaternion, *QuaternionA.Quaternion, *QuaternionB.Quaternion)
  Declare ProductByScalar(*QuaternionR.Quaternion, *QuaternionA.Quaternion, Scalar.f)
  Declare DivideByScalar(*QuaternionR.Quaternion, *QuaternionA.Quaternion, Scalar.f)
  Declare.f SquareModulus(*QuaternionA.Quaternion)
  Declare Conjugate(*QuaternionR.Quaternion, *QuaternionA.Quaternion)
  Declare Product(*QuaternionR.Quaternion, *QuaternionA.Quaternion, *QuaternionB.Quaternion)
  Declare Zero(*QuaternionA.Quaternion)
  Declare One(*QuaternionA.Quaternion)
  Declare Unit(*QuaternionR.Quaternion, *QuaternionA.Quaternion)
  Declare Invert(*QuaternionR.Quaternion, *QuaternionA.Quaternion)
  Declare Divide(*QuaternionR.Quaternion, *QuaternionA.Quaternion, *QuaternionB.Quaternion)
  
  Declare ReadQuaternion(FileID.l, *QuaternionA.Quaternion)
  Declare WriteQuaternion(FileID.l, *QuaternionA.Quaternion)
  
  Declare.s Format(*QuaternionA.Quaternion, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
  Declare Unformat(*QuaternionA.Quaternion, P_Quaternion.s, Brackets.s = "[]", Separator.s = ", ")
  
  CompilerIf Defined(Vector3, #PB_Module)
    Declare MakeFromAxisAngle(*QuaternionR.Quaternion, *Axis.Vector3::Vector3, Angle.f)
    Declare DirectRotation(*NewPoint.Vector3::Vector3, *Rotation.Quaternion, *Point.Vector3::Vector3)
    Declare DirectRotationTranslation(*NewPoint.Vector3::Vector3, *Rotation.Quaternion, *Translation.Vector3::Vector3, *Point.Vector3::Vector3)
  CompilerEndIf
  
EndDeclareModule

Module Quaternion
  
  Procedure.f GetS(*QuaternionA.Quaternion)
    
    ProcedureReturn *QuaternionA\s
  EndProcedure
  
  Procedure.f GetI(*QuaternionA.Quaternion)
    
    ProcedureReturn *QuaternionA\i
  EndProcedure
  
  Procedure.f GetJ(*QuaternionA.Quaternion)
    
    ProcedureReturn *QuaternionA\j
  EndProcedure
  
  Procedure.f GetK(*QuaternionA.Quaternion)
    
    ProcedureReturn *QuaternionA\k
  EndProcedure
  
  Procedure SetS(*QuaternionA.Quaternion, P_s.f)
    
    *QuaternionA\s = P_s
    
  EndProcedure
  
  Procedure SetI(*QuaternionA.Quaternion, P_i.f)
    
    *QuaternionA\i = P_i
    
  EndProcedure
  
  Procedure SetJ(*QuaternionA.Quaternion, P_j.f)
    
    *QuaternionA\j = P_j
    
  EndProcedure
  
  Procedure SetK(*QuaternionA.Quaternion, P_k.f)
    
    *QuaternionA\k = P_k
    
  EndProcedure
  
  Procedure Update(*QuaternionA.Quaternion, P_s.f, P_i.f, P_j.f, P_k.f)
    
    *QuaternionA\s = P_s
    *QuaternionA\i = P_i
    *QuaternionA\j = P_j
    *QuaternionA\k = P_k
    
  EndProcedure
  
  Procedure Reset(*QuaternionA.Quaternion)
    
    *QuaternionA\s = 0.0
    *QuaternionA\i = 0.0
    *QuaternionA\j = 0.0
    *QuaternionA\k = 0.0
    
  EndProcedure
  
  Procedure Copy(*QuaternionA.Quaternion, *QuaternionB.Quaternion)

    *QuaternionB\s = *QuaternionA\s
    *QuaternionB\i = *QuaternionA\i
    *QuaternionB\j = *QuaternionA\j
    *QuaternionB\k = *QuaternionA\k
    
  EndProcedure
  
  Procedure Compare(*QuaternionA.Quaternion, *QuaternionB.Quaternion)
    
    ProcedureReturn CompareMemory(*QuaternionA, *QuaternionB, SizeOf(Quaternion))
    
  EndProcedure
  
  Procedure Swapping(*QuaternionA.Quaternion, *QuaternionB.Quaternion)
    
    Swap *QuaternionA\s, *QuaternionB\s
    Swap *QuaternionA\i, *QuaternionB\i
    Swap *QuaternionA\j, *QuaternionB\j
    Swap *QuaternionA\k, *QuaternionB\k
    
  EndProcedure
  
  Procedure Equal(*QuaternionA.Quaternion, *QuaternionB.Quaternion)
    
    *QuaternionA\s = *QuaternionB\s
    *QuaternionA\i = *QuaternionB\i
    *QuaternionA\j = *QuaternionB\j
    *QuaternionA\k = *QuaternionB\k
    
  EndProcedure
  
  Procedure Plus(*QuaternionR.Quaternion, *QuaternionA.Quaternion, *QuaternionB.Quaternion)
    
    *QuaternionR\s = *QuaternionA\s + *QuaternionB\s
    *QuaternionR\i = *QuaternionA\i + *QuaternionB\i
    *QuaternionR\j = *QuaternionA\j + *QuaternionB\j
    *QuaternionR\k = *QuaternionA\k + *QuaternionB\k
    
  EndProcedure
  
  Procedure Minus(*QuaternionR.Quaternion, *QuaternionA.Quaternion, *QuaternionB.Quaternion)
    
    *QuaternionR\s = *QuaternionA\s - *QuaternionB\s
    *QuaternionR\i = *QuaternionA\i - *QuaternionB\i
    *QuaternionR\j = *QuaternionA\j - *QuaternionB\j
    *QuaternionR\k = *QuaternionA\k - *QuaternionB\k
    
  EndProcedure
  
  Procedure ProductByScalar(*QuaternionR.Quaternion, *QuaternionA.Quaternion, Scalar.f)
    
    *QuaternionR\s = *QuaternionA\s * Scalar
    *QuaternionR\i = *QuaternionA\i * Scalar
    *QuaternionR\j = *QuaternionA\j * Scalar
    *QuaternionR\k = *QuaternionA\k * Scalar
    
  EndProcedure
  
  Procedure DivideByScalar(*QuaternionR.Quaternion, *QuaternionA.Quaternion, Scalar.f)
    
    *QuaternionR\s = *QuaternionA\s / Scalar
    *QuaternionR\i = *QuaternionA\i / Scalar
    *QuaternionR\j = *QuaternionA\j / Scalar
    *QuaternionR\k = *QuaternionA\k / Scalar
    
  EndProcedure
  
  Procedure.f SquareModulus(*QuaternionA.Quaternion)
    
    ProcedureReturn (*QuaternionA\s * *QuaternionA\s + *QuaternionA\i * *QuaternionA\i + *QuaternionA\j * *QuaternionA\j + *QuaternionA\k * *QuaternionA\k)
    
  EndProcedure

  Procedure Conjugate(*QuaternionR.Quaternion, *QuaternionA.Quaternion)
    
    *QuaternionR\s = *QuaternionA\s
    *QuaternionR\i = -*QuaternionA\i
    *QuaternionR\j = -*QuaternionA\j
    *QuaternionR\k = -*QuaternionA\k
    
  EndProcedure
  
  Procedure Product(*QuaternionR.Quaternion, *QuaternionA.Quaternion, *QuaternionB.Quaternion)
    
    Temp.Quaternion\s = *QuaternionB\s * *QuaternionA\s - *QuaternionB\i * *QuaternionA\i - *QuaternionB\j * *QuaternionA\j - *QuaternionB\k * *QuaternionA\k
    Temp.Quaternion\i = *QuaternionB\s * *QuaternionA\i + *QuaternionB\i * *QuaternionA\s - *QuaternionB\j * *QuaternionA\k + *QuaternionB\k * *QuaternionA\j
    Temp.Quaternion\j = *QuaternionB\s * *QuaternionA\j + *QuaternionB\i * *QuaternionA\k + *QuaternionB\j * *QuaternionA\s - *QuaternionB\k * *QuaternionA\i
    Temp.Quaternion\k = *QuaternionB\s * *QuaternionA\k - *QuaternionB\i * *QuaternionA\j + *QuaternionB\j * *QuaternionA\i + *QuaternionB\k * *QuaternionA\s
    
    *QuaternionR\s = Temp\s
    *QuaternionR\i = Temp\i
    *QuaternionR\j = Temp\j
    *QuaternionR\k = Temp\k
    
  EndProcedure

  Procedure Zero(*QuaternionA.Quaternion)
    
    *QuaternionA\s = 0.0
    *QuaternionA\i = 0.0
    *QuaternionA\j = 0.0
    *QuaternionA\k = 0.0
    
  EndProcedure
  
  Procedure One(*QuaternionA.Quaternion)
    
    *QuaternionA\s = 1.0
    *QuaternionA\i = 1.0
    *QuaternionA\j = 1.0
    *QuaternionA\k = 1.0
    
  EndProcedure
 
  Procedure Unit(*QuaternionR.Quaternion, *QuaternionA.Quaternion)
    
    Unit_Quaternion_Modulus.f = Sqr(SquareModulus(*QuaternionA))
    
    If Unit_Quaternion_Modulus = 0.0
      *QuaternionA\s = 1.0
      *QuaternionA\i = 0.0
      *QuaternionA\j = 0.0
      *QuaternionA\k = 0.0
    Else
      DivideByScalar(*QuaternionR, *QuaternionA, Unit_Quaternion_Modulus)
    EndIf 
    
  EndProcedure 
  
  Procedure Invert(*QuaternionR.Quaternion, *QuaternionA.Quaternion)
    
    Square_Quaternion_Modulus.d = SquareModulus(*QuaternionA)
    
    If Square_Quaternion_Modulus <> 0.0
      *QuaternionR\s = *QuaternionA\s / Square_Quaternion_Modulus
      *QuaternionR\i = *QuaternionA\i / -Square_Quaternion_Modulus
      *QuaternionR\j = *QuaternionA\j / -Square_Quaternion_Modulus
      *QuaternionR\k = *QuaternionA\k / -Square_Quaternion_Modulus
    EndIf 
    
  EndProcedure 
  
  Procedure Divide(*QuaternionR.Quaternion, *QuaternionA.Quaternion, *QuaternionB.Quaternion)
    
    Copy(*QuaternionB, CopyB.Quaternion)
    Invert(CopyB, CopyB)
    Product(*QuaternionR, CopyB, *QuaternionA)
    
  EndProcedure
  
  Procedure ReadQuaternion(FileID.l, *QuaternionA.Quaternion)
    
    *QuaternionA\s = ReadFloat(FileID)
    *QuaternionA\i = ReadFloat(FileID)
    *QuaternionA\j = ReadFloat(FileID)
    *QuaternionA\k = ReadFloat(FileID)
    
  EndProcedure
  
  Procedure WriteQuaternion(FileID.l, *QuaternionA.Quaternion)
    
    WriteFloat(FileID, *QuaternionA\s)
    WriteFloat(FileID, *QuaternionA\i)
    WriteFloat(FileID, *QuaternionA\j)
    WriteFloat(FileID, *QuaternionA\k)
    
  EndProcedure
  
  Procedure.s Format(*QuaternionA.Quaternion, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
    
    ProcedureReturn Mid(Brackets, 1, 1) + StrF(*QuaternionA\s, Decimal) +  Separator + StrF(*QuaternionA\i, Decimal) + Separator + StrF(*QuaternionA\j, Decimal) + Separator + StrF(*QuaternionA\k, Decimal) + Mid(Brackets, 2, 1)
    
  EndProcedure
  
  Procedure Unformat(*QuaternionA.Quaternion, P_Quaternion.s, Brackets.s = "[]", Separator.s = ", ")
    
    *QuaternionA\s = ValF(StringField(StringField(StringField(P_Quaternion, 2, Mid(Brackets, 1, 1)), 1, Mid(Brackets, 2, 1)), 1, Separator))
    *QuaternionA\i = ValF(StringField(StringField(StringField(P_Quaternion, 2, Mid(Brackets, 1, 1)), 1, Mid(Brackets, 2, 1)), 2, Separator))
    *QuaternionA\j = ValF(StringField(StringField(StringField(P_Quaternion, 2, Mid(Brackets, 1, 1)), 1, Mid(Brackets, 2, 1)), 3, Separator))
    *QuaternionA\k = ValF(StringField(StringField(StringField(P_Quaternion, 2, Mid(Brackets, 1, 1)), 1, Mid(Brackets, 2, 1)), 4, Separator))
    
  EndProcedure
  
  CompilerIf Defined(Vector3, #PB_Module)
    
    Procedure MakeFromAxisAngle(*QuaternionR.Quaternion, *Axis.Vector3::Vector3, Angle.f)
      
      Protected HalfAngle.f, CosHalfAngle.f, SinHalfAngle.f
      
      HalfAngle = Angle * 0.5
      
      !FLD dword [p.v_HalfAngle]
      !FSINCOS
      !FSTP dword [p.v_CosHalfAngle]
      !FSTP dword [p.v_SinHalfAngle] 
      
      *QuaternionR\s = CosHalfAngle
      *QuaternionR\i = Vector3::GetI(*Axis) * SinHalfAngle
      *QuaternionR\j = Vector3::GetJ(*Axis) * SinHalfAngle
      *QuaternionR\k = Vector3::GetK(*Axis) * SinHalfAngle
      
      Unit(*QuaternionR, *QuaternionR)
      
    EndProcedure 
    
    Procedure DirectRotation(*NewPoint.Vector3::Vector3, *Rotation.Quaternion, *Point.Vector3::Vector3)
      
      t1.f = *Rotation\s * *Rotation\i
      t2.f = *Rotation\s * *Rotation\j
      t3.f = *Rotation\s * *Rotation\k
      t4.f = -*Rotation\i * *Rotation\i
      t5.f = *Rotation\i * *Rotation\j
      t6.f = *Rotation\i * *Rotation\k
      t7.f = -*Rotation\j * *Rotation\j
      t8.f = *Rotation\j * *Rotation\k
      t9.f = -*Rotation\k * *Rotation\k
      
      Vector3::SetI(*NewPoint, 2 * ((t7 + t9) * Vector3::GetI(*Point) + (t5 - t3) * Vector3::GetJ(*Point) + (t2 + t6) * Vector3::GetK(*Point)) + Vector3::GetI(*Point))
      Vector3::SetJ(*NewPoint, 2 * ((t3 + t5) * Vector3::GetI(*Point) + (t4 + t9) * Vector3::GetJ(*Point) + (t8 - t1) * Vector3::GetK(*Point)) + Vector3::GetJ(*Point))
      Vector3::SetK(*NewPoint, 2 * ((t6 - t2) * Vector3::GetI(*Point) + (t1 + t8) * Vector3::GetJ(*Point) + (t4 + t7) * Vector3::GetK(*Point)) + Vector3::GetK(*Point))
      
    EndProcedure

    Procedure DirectRotationTranslation(*NewPoint.Vector3::Vector3, *Rotation.Quaternion, *Translation.Vector3::Vector3, *Point.Vector3::Vector3)
      
      t1.f = *Rotation\s * *Rotation\i
      t2.f = *Rotation\s * *Rotation\j
      t3.f = *Rotation\s * *Rotation\k
      t4.f = -*Rotation\i * *Rotation\i
      t5.f = *Rotation\i * *Rotation\j
      t6.f = *Rotation\i * *Rotation\k
      t7.f = -*Rotation\j * *Rotation\j
      t8.f = *Rotation\j * *Rotation\k
      t9.f = -*Rotation\k * *Rotation\k
      
      Vector3::SetI(*NewPoint, 2 * ((t7 + t9) * Vector3::GetI(*Point) + (t5 - t3) * Vector3::GetJ(*Point) + (t2 + t6) * Vector3::GetK(*Point)) + Vector3::GetI(*Point) + Vector3::GetI(*Translation))
      Vector3::SetJ(*NewPoint, 2 * ((t3 + t5) * Vector3::GetI(*Point) + (t4 + t9) * Vector3::GetJ(*Point) + (t8 - t1) * Vector3::GetK(*Point)) + Vector3::GetJ(*Point) + Vector3::GetJ(*Translation))
      Vector3::SetK(*NewPoint, 2 * ((t6 - t2) * Vector3::GetI(*Point) + (t1 + t8) * Vector3::GetJ(*Point) + (t4 + t7) * Vector3::GetK(*Point)) + Vector3::GetK(*Point) + Vector3::GetK(*Translation))
      
    EndProcedure
    
  CompilerEndIf
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = -------
; EnableUnicode
; EnableXP
; CompileSourceDirectory