; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Gaming Maths library
; Nom du fichier : Vector3 - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : StarBootics
; Date : 06-08-2007
; Mise  jour : 02-03-2015
; Code PureBasic : V5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Vector3
  
  Structure Vector3
    i.f
    j.f
    k.f
  EndStructure
  
  Declare.f GetI(*VectorA.Vector3)
  Declare.f GetJ(*VectorA.Vector3)
  Declare.f GetK(*VectorA.Vector3)
  Declare SetI(*VectorA.Vector3, P_i.f)
  Declare SetJ(*VectorA.Vector3, P_j.f)
  Declare SetK(*VectorA.Vector3, P_k.f)
  Declare Update(*VectorA.Vector3, P_i.f, P_j.f, P_k.f)
  Declare Reset(*VectorA.Vector3)
  Declare Copy(*VectorA.Vector3, *VectorB.Vector3)
  Declare Compare(*VectorA.Vector3, *VectorB.Vector3)
  Declare Swapping(*VectorA.Vector3, *VectorB.Vector3)
  Declare Plus(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
  Declare Minus(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
  Declare Zero(*VectorA.Vector3)
  Declare One(*VectorA.Vector3)
  Declare ProductByScalar(*VectorR.Vector3, *VectorA.Vector3, Scalar.f)
  Declare DivideByScalar(*VectorR.Vector3, *VectorA.Vector3, Scalar.f)
  Declare ReadVector3(FileID, *VectorA.Vector3)
  Declare WriteVector3(FileID, *VectorA.Vector3)
  Declare AddXMLAttribute(CurrentNode, *VectorA.Vector3)
  Declare CollectXMLAttribute(CurrentNode, *VectorA.Vector3)
  Declare.s Format(*VectorA.Vector3, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
  Declare Unformat(*VectorA.Vector3, P_Vector3.s, Brackets.s = "[]", Separator.s = ", ")
  Declare.f DotProduct(*VectorA.Vector3, *VectorB.Vector3)
  Declare.f Modulus(*VectorA.Vector3)
  Declare.f SquareModulus(*VectorA.Vector3)
  Declare CrossProduct(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
  Declare MedianPosition(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
  Declare Lerp(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3, P_t.f)
  Declare AddScaled(*VectorR.Vector3, *VectorA.Vector3, Scale.f)
  Declare Unit(*VectorR.Vector3, *VectorA.Vector3 = #Null)
  Declare DefaultLocalAxis(*X_Axis.Vector3, *Y_Axis.Vector3, *Z_Axis.Vector3)
  Declare AimingPoint(*Amaing.Vector3, *Position.Vector3, *Direction.Vector3, Distance.f)
  
EndDeclareModule

Module Vector3
  
  Procedure.f GetI(*VectorA.Vector3)
    ProcedureReturn *VectorA\i
  EndProcedure
  
  Procedure.f GetJ(*VectorA.Vector3)
    ProcedureReturn *VectorA\j
  EndProcedure
  
  Procedure.f GetK(*VectorA.Vector3)
    ProcedureReturn *VectorA\k
  EndProcedure
  
  Procedure SetI(*VectorA.Vector3, P_i.f)
    *VectorA\i = P_i
  EndProcedure
  
  Procedure SetJ(*VectorA.Vector3, P_j.f)
    *VectorA\j = P_j
  EndProcedure
  
  Procedure SetK(*VectorA.Vector3, P_k.f)
    *VectorA\k = P_k
  EndProcedure
  
  Procedure Update(*VectorA.Vector3, P_i.f, P_j.f, P_k.f)
    *VectorA\i = P_i
    *VectorA\j = P_j
    *VectorA\k = P_k
  EndProcedure
  
  Procedure Reset(*VectorA.Vector3)
    *VectorA\i = 0.0
    *VectorA\j = 0.0
    *VectorA\k = 0.0
  EndProcedure
  
  Procedure Copy(*VectorA.Vector3, *VectorB.Vector3)
    *VectorB\i = *VectorA\i
    *VectorB\j = *VectorA\j
    *VectorB\k = *VectorA\k
  EndProcedure
  
  Procedure Compare(*VectorA.Vector3, *VectorB.Vector3)
    
    ProcedureReturn CompareMemory(*VectorA, *VectorB, SizeOf(Vector3))
  EndProcedure
  
  Procedure Swapping(*VectorA.Vector3, *VectorB.Vector3)
    Swap *VectorA\i, *VectorB\i
    Swap *VectorA\j, *VectorB\j
    Swap *VectorA\k, *VectorB\k
  EndProcedure
  
  Procedure Plus(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
    *VectorR\i = *VectorA\i + *VectorB\i
    *VectorR\j = *VectorA\j + *VectorB\j
    *VectorR\k = *VectorA\k + *VectorB\k
  EndProcedure
  
  Procedure PlusEx(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3, *VectorC.Vector3)
    *VectorR\i = *VectorA\i + *VectorB\i + *VectorC\i
    *VectorR\j = *VectorA\j + *VectorB\j + *VectorC\j
    *VectorR\k = *VectorA\k + *VectorB\k + *VectorC\k
  EndProcedure
  
  Procedure Minus(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
    *VectorR\i = *VectorA\i - *VectorB\i
    *VectorR\j = *VectorA\j - *VectorB\j
    *VectorR\k = *VectorA\k - *VectorB\k
  EndProcedure
  
  Procedure MinusEx(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3, *VectorC.Vector3)
    *VectorR\i = *VectorA\i - *VectorB\i - *VectorC\i
    *VectorR\j = *VectorA\j - *VectorB\j - *VectorC\j
    *VectorR\k = *VectorA\k - *VectorB\k - *VectorC\k
  EndProcedure
  
  Procedure Zero(*VectorA.Vector3)
    *VectorA\i = 0.0
    *VectorA\j = 0.0
    *VectorA\k = 0.0
  EndProcedure
  
  Procedure One(*VectorA.Vector3)
    *VectorA\i = 1.0
    *VectorA\j = 1.0
    *VectorA\k = 1.0
  EndProcedure
  
  Procedure ProductByScalar(*VectorR.Vector3, *VectorA.Vector3, Scalar.f)
    *VectorR\i = *VectorA\i * Scalar
    *VectorR\j = *VectorA\j * Scalar
    *VectorR\k = *VectorA\k * Scalar
  EndProcedure
  
  Procedure DivideByScalar(*VectorR.Vector3, *VectorA.Vector3, Scalar.f)
    *VectorR\i = *VectorA\i / Scalar
    *VectorR\j = *VectorA\j / Scalar
    *VectorR\k = *VectorA\k / Scalar
  EndProcedure
  
  Procedure ReadVector3(FileID, *VectorA.Vector3)
    *VectorA\i = ReadFloat(FileID)
    *VectorA\j = ReadFloat(FileID)
    *VectorA\k = ReadFloat(FileID)
  EndProcedure
  
  Procedure WriteVector3(FileID, *VectorA.Vector3)
    WriteFloat(FileID, *VectorA\i)
    WriteFloat(FileID, *VectorA\j)
    WriteFloat(FileID, *VectorA\k)
  EndProcedure
  
  Procedure AddXMLAttribute(CurrentNode, *VectorA.Vector3) 
    SetXMLAttribute(CurrentNode, "i", StrF(*VectorA\i, 6))
    SetXMLAttribute(CurrentNode, "j", StrF(*VectorA\j, 6))
    SetXMLAttribute(CurrentNode, "k", StrF(*VectorA\k, 6))
  EndProcedure
  
  Procedure CollectXMLAttribute(CurrentNode, *VectorA.Vector3)
    *VectorA\i = ValF(GetXMLAttribute(CurrentNode, "i"))
    *VectorA\j = ValF(GetXMLAttribute(CurrentNode, "j"))
    *VectorA\k = ValF(GetXMLAttribute(CurrentNode, "k"))
  EndProcedure

  Procedure.s Format(*VectorA.Vector3, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
    
    ProcedureReturn Mid(Brackets,1,1) + StrF(*VectorA\i, Decimal) + Separator + StrF(*VectorA\j, Decimal) + Separator + StrF(*VectorA\k, Decimal) + Mid(Brackets,2,1)
  EndProcedure
  
  Procedure Unformat(*VectorA.Vector3, P_Vector3.s, Brackets.s = "[]", Separator.s = ", ")
    
    *VectorA\i = ValF(StringField(StringField(StringField(P_Vector3, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 1, Separator))
    *VectorA\j = ValF(StringField(StringField(StringField(P_Vector3, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 2, Separator))
    *VectorA\k = ValF(StringField(StringField(StringField(P_Vector3, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 2, Separator))
    
  EndProcedure
  
  Procedure.f DotProduct(*VectorA.Vector3, *VectorB.Vector3)
    
    ProcedureReturn *VectorA\i * *VectorB\i + *VectorA\j * *VectorB\j + *VectorA\k * *VectorB\k
  EndProcedure
  
  Procedure.f Modulus(*VectorA.Vector3)
    
    ProcedureReturn Sqr(*VectorA\i * *VectorA\i + *VectorA\j * *VectorA\j + *VectorA\k * *VectorA\k)
  EndProcedure
  
    Procedure.f SquareModulus(*VectorA.Vector3)
    
    ProcedureReturn *VectorA\i * *VectorA\i + *VectorA\j * *VectorA\j + *VectorA\k * *VectorA\k
  EndProcedure
  
  Procedure CrossProduct(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
    
    *VectorR\i = *VectorA\j * *VectorB\k - *VectorA\k * *VectorB\j
    *VectorR\j = *VectorA\k * *VectorB\i - *VectorA\i * *VectorB\k
    *VectorR\k = *VectorA\i * *VectorB\j - *VectorA\j * *VectorB\i

  EndProcedure
 
  Procedure MedianPosition(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3)
    *VectorR\i = (*VectorA\i + *VectorB\i) / 2.0
    *VectorR\j = (*VectorA\j + *VectorB\j) / 2.0
    *VectorR\k = (*VectorA\k + *VectorB\k) / 2.0
  EndProcedure
  
  Procedure Lerp(*VectorR.Vector3, *VectorA.Vector3, *VectorB.Vector3, P_t.f)
    *VectorR\i = *VectorA\i + P_t * (*VectorB\i - *VectorA\i) 
    *VectorR\j = *VectorA\j + P_t * (*VectorB\j - *VectorA\j)
    *VectorR\k = *VectorA\k + P_t * (*VectorB\k - *VectorA\k)
  EndProcedure
  
  Procedure AddScaled(*VectorR.Vector3, *VectorA.Vector3, Scale.f)
    *VectorR\i = *VectorR\i + *VectorA\i * Scale
    *VectorR\j = *VectorR\j + *VectorA\j * Scale
    *VectorR\k = *VectorR\k + *VectorA\k * Scale
  EndProcedure

  Procedure Unit(*VectorR.Vector3, *VectorA.Vector3 = #Null)
    
    ; Le calcule du module dans une variable tampon est ncessaire puisque
    ; l'criture et la lecture se fait dans la mme zone mmoire.
    ; Le calcul du module dpend de la valeur i, j et k du vecteur.

    If *VectorA <> #Null
      
      Unit_Vector3_Modulus.f = Modulus(*VectorA)
      
      If Unit_Vector3_Modulus <> 0.0
        DivideByScalar(*VectorR, *VectorA, Unit_Vector3_Modulus)
      EndIf 
      
    Else
      
      Unit_Vector3_Modulus.f = Modulus(*VectorR)
      
      If Unit_Vector3_Modulus <> 0.0
        DivideByScalar(*VectorR, *VectorR, Unit_Vector3_Modulus)
      EndIf 
      
    EndIf
    
  EndProcedure 
  
  Procedure DefaultLocalAxis(*X_Axis.Vector3, *Y_Axis.Vector3, *Z_Axis.Vector3)
    
    *X_Axis\i = 1.0
    *X_Axis\j = 0.0
    *X_Axis\k = 0.0
    
    *Y_Axis\i = 0.0
    *Y_Axis\j = 1.0
    *Y_Axis\k = 0.0
    
    *Z_Axis\i = 0.0
    *Z_Axis\j = 0.0
    *Z_Axis\k = 1.0
    
  EndProcedure 

  Procedure AimingPoint(*Amaing.Vector3, *Position.Vector3, *Direction.Vector3, Distance.f)
    
    *Amaing\i = *Position\i + (*Direction\i * Distance)
    *Amaing\j = *Position\j + (*Direction\j * Distance)
    *Amaing\k = *Position\k + (*Direction\k * Distance)
    
  EndProcedure

EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Vector3::One(VecteurA.Vector3::Vector3)
  Vector3::One(VecteurB.Vector3::Vector3)  
  
  Debug Vector3::Compare(VecteurA, VecteurB)
  
  Vector3::Plus(VecteurR.Vector3::Vector3, VecteurA, VecteurB)
  
  Debug Vector3::Format(VecteurR)
  
  Vector3::DefaultLocalAxis(X_Axis.Vector3::Vector3, Y_Axis.Vector3::Vector3, Z_Axis.Vector3::Vector3)
  
  Vector3::AimingPoint(Amaing.Vector3::Vector3, Position.Vector3::Vector3, Z_Axis, 2500)
  Debug ""
  Debug Vector3::Format(Position)
  Debug Vector3::Format(Z_Axis)
  Debug Vector3::Format(Amaing)
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = -------
; EnableUnicode
; EnableXP
; CompileSourceDirectory