; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Gaming Maths library
; Nom du fichier : Vector4 - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : StarBootics
; Date : 06-08-2007
; Mise  jour : 02-03-2015
; Code PureBasic : V5.31
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Vector4
  
  Structure Vector4
    i.f
    j.f
    k.f
    l.f
  EndStructure
  
  Declare.f GetI(*VectorA.Vector4)
  Declare.f GetJ(*VectorA.Vector4)
  Declare.f GetK(*VectorA.Vector4)
  Declare.f GetL(*VectorA.Vector4)
  
  Declare SetI(*VectorA.Vector4, P_i.f)
  Declare SetJ(*VectorA.Vector4, P_j.f)
  Declare SetK(*VectorA.Vector4, P_k.f)
  Declare SetL(*VectorA.Vector4, P_l.f)
  
  Declare Update(*VectorA.Vector4, P_i.f, P_j.f, P_k.f, P_l.f)
  Declare Reset(*VectorA.Vector4)
  Declare Copy(*VectorA.Vector4, *VectorB.Vector4)
  Declare Compare(*VectorA.Vector4, *VectorB.Vector4)
  Declare Swapping(*VectorA.Vector4, *VectorB.Vector4)
  Declare Plus(*VectorR.Vector4, *VectorA.Vector4, *VectorB.Vector4)
  Declare Minus(*VectorR.Vector4, *VectorA.Vector4, *VectorB.Vector4)
  Declare Zero(*VectorA.Vector4)
  Declare One(*VectorA.Vector4)
  Declare ProductByScalar(*VectorR.Vector4, *VectorA.Vector4, Scalar.f)
  Declare DivideByScalar(*VectorR.Vector4, *VectorA.Vector4, Scalar.f)
  Declare ReadVector4(FileID, *VectorA.Vector4)
  Declare WriteVector4(FileID, *VectorA.Vector4)
  Declare AddXMLAttribute(CurrentNode, *VectorA.Vector4)
  Declare CollectXMLAttribute(CurrentNode, *VectorA.Vector4)
  Declare.s Format(*VectorA.Vector4, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
  Declare Unformat(*VectorA.Vector4, P_Vector4.s, Brackets.s = "[]", Separator.s = ", ")
  Declare.f DotProduct(*VectorA.Vector4, *VectorB.Vector4)
  Declare.f Modulus(*VectorA.Vector4)
  Declare Lerp(*VectorR.Vector4, *VectorA.Vector4, *VectorB.Vector4, P_t.f)
  Declare AddScaled(*VectorR.Vector4, *VectorA.Vector4, Scale.f)
  Declare Unit(*VectorR.Vector4, *VectorA.Vector4 = #Null)
  
EndDeclareModule

Module Vector4
  
  Procedure.f GetI(*VectorA.Vector4)
    ProcedureReturn *VectorA\i
  EndProcedure
  
  Procedure.f GetJ(*VectorA.Vector4)
    ProcedureReturn *VectorA\j
  EndProcedure
  
  Procedure.f GetK(*VectorA.Vector4)
    ProcedureReturn *VectorA\k
  EndProcedure
  
  Procedure.f GetL(*VectorA.Vector4)
    ProcedureReturn *VectorA\l
  EndProcedure
  
  Procedure SetI(*VectorA.Vector4, P_i.f)
    *VectorA\i = P_i
  EndProcedure
  
  Procedure SetJ(*VectorA.Vector4, P_j.f)
    *VectorA\j = P_j
  EndProcedure
  
  Procedure SetK(*VectorA.Vector4, P_k.f)
    *VectorA\k = P_k
  EndProcedure
  
  Procedure SetL(*VectorA.Vector4, P_l.f)
    *VectorA\l = P_l
  EndProcedure
  
  Procedure Update(*VectorA.Vector4, P_i.f, P_j.f, P_k.f, P_l.f)
    *VectorA\i = P_i
    *VectorA\j = P_j
    *VectorA\k = P_k
    *VectorA\l = P_l
  EndProcedure
  
  Procedure Reset(*VectorA.Vector4)
    *VectorA\i = 0.0
    *VectorA\j = 0.0
    *VectorA\k = 0.0
    *VectorA\l = 0.0
  EndProcedure
  
  Procedure Copy(*VectorA.Vector4, *VectorB.Vector4)
    *VectorB\i = *VectorA\i
    *VectorB\j = *VectorA\j
    *VectorB\k = *VectorA\k
    *VectorB\l = *VectorA\l
  EndProcedure
  
  Procedure Compare(*VectorA.Vector4, *VectorB.Vector4)
    
    ProcedureReturn CompareMemory(*VectorA, *VectorB, SizeOf(Vector4))
  EndProcedure
  
  Procedure Swapping(*VectorA.Vector4, *VectorB.Vector4)
    Swap *VectorA\i, *VectorB\i
    Swap *VectorA\j, *VectorB\j
    Swap *VectorA\k, *VectorB\k
    Swap *VectorA\l, *VectorB\l
  EndProcedure
  
  Procedure Plus(*VectorR.Vector4, *VectorA.Vector4, *VectorB.Vector4)
    *VectorR\i = *VectorA\i + *VectorB\i
    *VectorR\j = *VectorA\j + *VectorB\j
    *VectorR\k = *VectorA\k + *VectorB\k
    *VectorR\l = *VectorA\l + *VectorB\l
  EndProcedure
  
  Procedure PlusEx(*VectorR.Vector4, *VectorA.Vector4, *VectorB.Vector4, *VectorC.Vector4)
    *VectorR\i = *VectorA\i + *VectorB\i + *VectorC\i
    *VectorR\j = *VectorA\j + *VectorB\j + *VectorC\j
    *VectorR\k = *VectorA\k + *VectorB\k + *VectorC\k
    *VectorR\l = *VectorA\l + *VectorB\l + *VectorC\l
  EndProcedure
  
  Procedure Minus(*VectorR.Vector4, *VectorA.Vector4, *VectorB.Vector4)
    *VectorR\i = *VectorA\i - *VectorB\i
    *VectorR\j = *VectorA\j - *VectorB\j
    *VectorR\k = *VectorA\k - *VectorB\k
    *VectorR\l = *VectorA\l - *VectorB\l
  EndProcedure
  
  Procedure MinusEx(*VectorR.Vector4, *VectorA.Vector4, *VectorB.Vector4, *VectorC.Vector4)
    *VectorR\i = *VectorA\i - *VectorB\i - *VectorC\i
    *VectorR\j = *VectorA\j - *VectorB\j - *VectorC\j
    *VectorR\k = *VectorA\k - *VectorB\k - *VectorC\k
    *VectorR\l = *VectorA\l - *VectorB\l - *VectorC\l
  EndProcedure
  
  Procedure Zero(*VectorA.Vector4)
    *VectorA\i = 0.0
    *VectorA\j = 0.0
    *VectorA\k = 0.0
    *VectorA\l = 0.0
  EndProcedure
  
  Procedure One(*VectorA.Vector4)
    *VectorA\i = 1.0
    *VectorA\j = 1.0
    *VectorA\k = 1.0
    *VectorA\l = 1.0
  EndProcedure
  
  Procedure ProductByScalar(*VectorR.Vector4, *VectorA.Vector4, Scalar.f)
    *VectorR\i = *VectorA\i * Scalar
    *VectorR\j = *VectorA\j * Scalar
    *VectorR\k = *VectorA\k * Scalar
    *VectorR\l = *VectorA\l * Scalar
  EndProcedure
  
  Procedure DivideByScalar(*VectorR.Vector4, *VectorA.Vector4, Scalar.f)
    *VectorR\i = *VectorA\i / Scalar
    *VectorR\j = *VectorA\j / Scalar
    *VectorR\k = *VectorA\k / Scalar
    *VectorR\l = *VectorA\l / Scalar
  EndProcedure
  
  Procedure ReadVector4(FileID, *VectorA.Vector4)
    *VectorA\i = ReadFloat(FileID)
    *VectorA\j = ReadFloat(FileID)
    *VectorA\k = ReadFloat(FileID)
    *VectorA\l = ReadFloat(FileID)
  EndProcedure
  
  Procedure WriteVector4(FileID, *VectorA.Vector4)
    WriteFloat(FileID, *VectorA\i)
    WriteFloat(FileID, *VectorA\j)
    WriteFloat(FileID, *VectorA\k)
    WriteFloat(FileID, *VectorA\l)
  EndProcedure
  
  Procedure AddXMLAttribute(CurrentNode, *VectorA.Vector4) 
    SetXMLAttribute(CurrentNode, "i", StrF(*VectorA\i, 6))
    SetXMLAttribute(CurrentNode, "j", StrF(*VectorA\j, 6))
    SetXMLAttribute(CurrentNode, "k", StrF(*VectorA\k, 6))
    SetXMLAttribute(CurrentNode, "l", StrF(*VectorA\l, 6))
  EndProcedure
  
  Procedure CollectXMLAttribute(CurrentNode, *VectorA.Vector4)
    *VectorA\i = ValF(GetXMLAttribute(CurrentNode, "i"))
    *VectorA\j = ValF(GetXMLAttribute(CurrentNode, "j"))
    *VectorA\k = ValF(GetXMLAttribute(CurrentNode, "k"))
    *VectorA\l = ValF(GetXMLAttribute(CurrentNode, "l"))
  EndProcedure

  Procedure.s Format(*VectorA.Vector4, Decimal.b = 3, Brackets.s = "[]", Separator.s = ", ")
    
    ProcedureReturn Mid(Brackets,1,1) + StrF(*VectorA\i, Decimal) + Separator + StrF(*VectorA\j, Decimal) + Separator + StrF(*VectorA\k, Decimal) + Separator + StrF(*VectorA\l, Decimal) + Mid(Brackets,2,1)
  EndProcedure
  
  Procedure Unformat(*VectorA.Vector4, P_Vector4.s, Brackets.s = "[]", Separator.s = ", ")
    
    *VectorA\i = ValF(StringField(StringField(StringField(P_Vector4, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 1, Separator))
    *VectorA\j = ValF(StringField(StringField(StringField(P_Vector4, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 2, Separator))
    *VectorA\k = ValF(StringField(StringField(StringField(P_Vector4, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 2, Separator))
    *VectorA\l = ValF(StringField(StringField(StringField(P_Vector4, 2, Mid(Brackets,1,1)), 1, Mid(Brackets,2,1)), 2, Separator))
    
  EndProcedure
  
  Procedure.f DotProduct(*VectorA.Vector4, *VectorB.Vector4)
    
    ProcedureReturn *VectorA\i * *VectorB\i + *VectorA\j * *VectorB\j + *VectorA\k * *VectorB\k + *VectorA\l * *VectorB\l
  EndProcedure
  
  Procedure.f Modulus(*VectorA.Vector4)
    
    ProcedureReturn Sqr(*VectorA\i * *VectorA\i + *VectorA\j * *VectorA\j + *VectorA\k * *VectorA\k + *VectorA\l * *VectorA\l)
  EndProcedure
  
  Procedure Lerp(*VectorR.Vector4, *VectorA.Vector4, *VectorB.Vector4, P_t.f)
    *VectorR\i = *VectorA\i + P_t * (*VectorB\i - *VectorA\i) 
    *VectorR\j = *VectorA\j + P_t * (*VectorB\j - *VectorA\j)
    *VectorR\k = *VectorA\k + P_t * (*VectorB\k - *VectorA\k)
    *VectorR\l = *VectorA\l + P_t * (*VectorB\l - *VectorA\l)
  EndProcedure
  
  Procedure AddScaled(*VectorR.Vector4, *VectorA.Vector4, Scale.f)
    *VectorR\i = *VectorR\i + *VectorA\i * Scale
    *VectorR\j = *VectorR\j + *VectorA\j * Scale
    *VectorR\k = *VectorR\k + *VectorA\k * Scale
    *VectorR\l = *VectorR\l + *VectorA\l * Scale
  EndProcedure

  Procedure Unit(*VectorR.Vector4, *VectorA.Vector4 = #Null)
    
    ; Le calcule du module dans une variable tampon est ncessaire puisque
    ; l'criture et la lecture se fait dans la mme zone mmoire.
    ; Le calcul du module dpend de la valeur i, j et k du vecteur.

    If *VectorA <> #Null
      
      Unit_Vector4_Modulus.f = Modulus(*VectorA)
      
      If Unit_Vector4_Modulus <> 0.0
        DivideByScalar(*VectorR, *VectorA, Unit_Vector4_Modulus)
      EndIf 
      
    Else
      
      Unit_Vector4_Modulus.f = Modulus(*VectorR)
      
      If Unit_Vector4_Modulus <> 0.0
        DivideByScalar(*VectorR, *VectorR, Unit_Vector4_Modulus)
      EndIf 
      
    EndIf
    
  EndProcedure 
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Vector4::One(VecteurA.Vector4::Vector4)
  Vector4::One(VecteurB.Vector4::Vector4)  
  
  Debug Vector4::Compare(VecteurA, VecteurB)
  
  Vector4::Plus(VecteurR.Vector4::Vector4, VecteurA, VecteurB)
  
  Debug Vector4::Format(VecteurR)
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.42 LTS (Linux - x64)
; Folding = -------
; EnableUnicode
; EnableXP
; CompileSourceDirectory